
//  bubble sort routines 
//  
//  Author			:  Xkey
//	Dte of Coding :	9-9-99
//  Description :
//				Just 2 simple templated versions of a bubble sort routine
//				One sorts the input into non-increasing order
//        the other sorts the input into non-decreasing order
//        Input is a vector<t> list of class t items
//
//				NOTE :	these templated versions REQUIRE class t to
//									 have a less than operator   '<'
//				NOTE :  this can be remedied if one uses a function object
//									to do the comparisons
//        NOTE :  there is a slight inefficiency introduced in
//									the bubble_sort_incr ...owing to using only
//										the '<' operator .... items that are equal
//										will end up getting swapped even tho
//										it is unnecessary
#include <vector>
#include  "bubble_sort.h"


using namespace std;


// non-decreasing order
template<class t>
int	bubble_sort_incr(vector<t> &list)
{

	bool  swapmade;
	t temp;
	int i, j;
	int bound = list.size();
	cout << "bound " << bound << '\n' ;


	for (i = 0; i < bound; i++ )
	  {
			swapmade = false;
	    for (j = 1; j < (bound - i); j++)
				{
           if (!(list[j - 1] < list[j]))
             { // need to swap em
							 temp = list[j-1];
							 list[j-1] = list[j];
							 list[j] = temp;

							 swapmade = true;
             }
				}
      if (swapmade == false)
        break;
	  }
	return 0;
}


// non-increasing order
template<class t>
int	bubble_sort_decr(vector<t> &list)
{

	bool  swapmade;
	t temp;
	int i, j;
	int bound = list.size();
	cout << "bound " << bound << '\n' ;


	for (i = 0; i < bound; i++ )
	  {
			swapmade = false;
	    for (j = 1; j < (bound - i); j++)
				{
           if (list[j - 1] < list[j])
             { // need to swap em
							 temp = list[j-1];
							 list[j-1] = list[j];
							 list[j] = temp;

							 swapmade = true;
             }
				}
      if (swapmade == false)
        break;
	  }
	return 0;
}

